#version 430 core

layout (points) in;								
layout (triangle_strip, max_vertices = 4) out;	

uniform mat4 projectionMatrix;					

in vertexData 
{
	float TTL1;
} vertex[];

out vec2 texCoords;	
flat out float TTL0;

void main (void) {

	const vec2 particleSize = vec2(0.5,0.5);			
	vec4 P = gl_in[0].gl_Position;						

	// a: left-bottom
	vec2 va = P.xy + vec2(-0.5, -0.5) * particleSize;	
	gl_Position = projectionMatrix * vec4(va, P.zw);	
	texCoords = vec2(0.0, 0.0);							
	TTL0 = vertex[0].TTL1;								
	EmitVertex();										

	// d: right-bottom
	vec2 vd = P.xy + vec2(0.5, -0.5) * particleSize;
	gl_Position = projectionMatrix * vec4(vd, P.zw);
	texCoords = vec2(1.0, 0.0);
	TTL0 = vertex[0].TTL1;
	EmitVertex();  

	// b: left-top
	vec2 vb = P.xy + vec2(-0.5, 0.5) * particleSize;
	gl_Position = projectionMatrix * vec4(vb, P.zw);
	texCoords = vec2(0.0, 1.0);
	TTL0 = vertex[0].TTL1;
	EmitVertex();  
  
	// c: right-top
	vec2 vc = P.xy + vec2(0.5, 0.5) * particleSize;
	gl_Position = projectionMatrix * vec4(vc, P.zw);
	texCoords = vec2(1.0, 1.0);
	TTL0 = vertex[0].TTL1;
	EmitVertex(); 

	EndPrimitive();		// completes the current output primitive on the first vertex stream (= finishes quad)
}