#version 430 core

layout (location = 0) in vec3 aPosition;
layout (location = 1) in vec3 aNormal;

out vec3 normal;
out vec3 position;

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;

void main() {
	normal = mat3(transpose(inverse(model))) * aNormal;
	position = vec3(model * vec4(aPosition,1.0));
	gl_Position = projection * view * model * vec4(aPosition, 1.0);
}